package rozdzial25c;

import javafx.application.Application;
import javafx.application.Platform;
import javafx.scene.Group;
import javafx.scene.Scene;
import javafx.scene.canvas.Canvas;
import javafx.scene.canvas.GraphicsContext;
import javafx.scene.image.PixelWriter;
import javafx.stage.Stage;

public class Listing25_27d extends Application {
    private static final int w = 560;
    private static final double min = -2.0;
    private static final double max = 2.0;
    private static final double scale = (max - min) / w;
    private static final double s = 2.0;
    private final int liczbaIteracji = 512;
    private final double re = -0.612;
    private final double im = 0.48;

    public static void main(String[] args) {
        Application.launch(args);
    }

    @Override
    public void start(Stage stage) {
        try {
            Group root = new Group();
            Canvas cv = new Canvas(560, 560);
            GraphicsContext gc = cv.getGraphicsContext2D();
            //-
            PixelWriter pw = gc.getPixelWriter();
            for (int i = 0; i < w; i++) {
                for (int j = 0; j < w; j++) {
                    double zr = min + j * scale;
                    double zi = min + i * scale;
                    int licz = liczIter(zr, zi);
                    int a = 255;
                    int r = licz << 7;
                    int g = licz << 5;
                    int b = licz << 6;
                    pw.setArgb(j, i, ARGBtoInt(a, r, g, b));
                }
            }

           //-
            root.getChildren().add(cv);
            Scene scene = new Scene(root);
            stage.setScene(scene);
            stage.setTitle("Metoda drawImage");
            stage.setOnCloseRequest(e -> Platform.exit());
            stage.show();

        } catch (Exception e) {
            e.printStackTrace();
        }
    }
    private int liczIter(double zre, double zim) {
        double kwad = 0;
        int licznik = 0;
        while ((kwad < s * s) && (licznik < liczbaIteracji)) {
            double temp = zre * zre - zim * zim + re;
            zim = s * zre * zim + im;
            zre = temp;
            kwad = zim * zim + zre * zre;
            licznik++;
        }
        return liczbaIteracji - licznik;
    }
    private static int ARGBtoInt(int a, int r, int g, int b) {
        return (a << 24) | (r << 16) | (g << 8) | b;
    }
}
